﻿using PC_Build_Games_SQL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для ChangePassword.xaml
    /// </summary>
    public partial class ChangePassword : Window
    {
        string username;
        public ChangePassword(string username)
        {
            InitializeComponent();
            this.username = username;
        }

        private void ToggleButton_Checked(object sender, RoutedEventArgs e)
        {
            ToggleButton toggleButton = (ToggleButton)sender;
            string passwordBoxName = toggleButton.Tag.ToString();

            PasswordBox passwordBox = FindName(passwordBoxName) as PasswordBox;
            if (passwordBox != null)
            {
                passwordBox.PasswordChar = '\0'; // Показывать символы пароля
            }
        }

        private void ToggleButton_Unchecked(object sender, RoutedEventArgs e)
        {
            ToggleButton toggleButton = (ToggleButton)sender;
            string passwordBoxName = toggleButton.Tag.ToString();

            PasswordBox passwordBox = FindName(passwordBoxName) as PasswordBox;
            if (passwordBox != null)
            {
                passwordBox.PasswordChar = '*'; // Скрыть символы пароля
            }
        }


        private void Button_Click(object sender, RoutedEventArgs e)
        {
            SQL sQL = new SQL();

            string temp = sQL.UserEditing(username, passwordBox1.Password, passwordBox2.Password, passwordBox3.Password);

            MessageBox.Show(temp);

            if (temp == "Пароль успешно изменен")
            {
                Close();
            }
        }
    }
}
