﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PC_Build_Games_SQL;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для CheckConfigure.xaml
    /// </summary>
    public partial class CheckConfigure : Page
    {
        string username;
        public CheckConfigure(string username)
        {
            InitializeComponent();
            this.username = username;
            fillComboBox();
        }

        public void fillComboBox()
        {
            SQL sql = new SQL();
            configureComboBox.ItemsSource = sql.ListOfConfigurations(username);
            configureComboBox.SelectedIndex = 0;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            SQL sql = new SQL();
            List<string> list = sql.PartsList((string)configureComboBox.SelectedValue);
            panelParts.Visibility = Visibility;
            gpuName.Text = list[0];
            cpuName.Text = list[1];
            ramName.Text = list[2];
        }
    }
}
