﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using PC_Build_Games_SQL;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для RegistrationWindow.xaml
    /// </summary>
    public partial class RegistrationWindow : Window
    {
        public RegistrationWindow()
        {
            InitializeComponent();
        }

        private void toLoginButton_Click(object sender, RoutedEventArgs e)
        {
            MainWindow main = new MainWindow();
            main.Show();
            Close();
        }

        private void RegistrationButton_Click(object sender, RoutedEventArgs e)
        {
            SQL sql = new SQL();
            switch (sql.Registration(nameTextBox.Text, surnameTextBox.Text, nicknameTextBox.Text, emailTextBox.Text, passwordBox.Password))
            {
                case 0:
                    MessageBox.Show("Вы успешно зарегесторировались");
                    MainWindow main = new MainWindow();
                    main.Show();
                    Close();
                    break;
                case 1:
                    MessageBox.Show("Поля должны быть заполнены");
                    break;
                case 2:
                    MessageBox.Show("Пользователь с таким ником уже существует");
                    break;
                case 3:
                    MessageBox.Show("Пользователь с таким адрессом электронной почты уже существует");
                    break;
                case 4:
                    MessageBox.Show("Имя не должно начинаться с пробела, заканчиваться на пробел, иметь 2 пробела в тексте");
                    break;
                case 5:
                    MessageBox.Show("Почта имеет неверный формат");
                    break;
                case 6:
                    MessageBox.Show("Пароль не соответствует требованиям");
                    break;
            }                       
        }
        
    }
}
