﻿using PC_Build_Games_SQL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для CheckCompatibility.xaml
    /// </summary>
    public partial class CheckCompatibility : Page
    {
        string username;
        public CheckCompatibility(string username)
        {
            InitializeComponent();
            this.username = username;
            FillComboBox();
        }

        void FillComboBox()
        {
            SQL sql = new SQL();
            configList.ItemsSource = sql.ListOfConfigurations(username);
            configList.SelectedIndex = 0;

            appList.ItemsSource = sql.Listofprograms();
            appList.SelectedIndex = 0;
        }

        private void CheckCompat_Click(object sender, RoutedEventArgs e)
        {
            SQL sql = new SQL();
            MessageBox.Show(sql.CompatibilityCheck((string)configList.SelectedValue, (string)appList.SelectedValue));
        }
    }
}
