﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PC_Build_Games_SQL;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для CreateConfigure.xaml
    /// </summary>
    public partial class CreateConfigure : Page
    {
        string username;
        public CreateConfigure(string username)
        {
            InitializeComponent();
            this.username = username;
            FillComboBox();
        }

        public void FillComboBox()
        {
            SQL sql = new SQL();
            videocardComboBox.ItemsSource = sql.CPUGPUList("GPU");
            videocardComboBox.SelectedIndex = 0;
            cpuComboBox.ItemsSource = sql.CPUGPUList("CPU");
            cpuComboBox.SelectedIndex = 0;
            List<string> list = new List<string>(5);
            for (int i = 2; i <= 32; i *= 2)
            {
                list.Add(i.ToString());
            }
            ramComboBox.ItemsSource = list;
            ramComboBox.SelectedIndex = 0;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            SQL sql = new SQL();
            if (nameConfig.Text != "")
            {
                sql.New_configuration(username, Convert.ToString(videocardComboBox.SelectedValue), Convert.ToString(cpuComboBox.SelectedValue), Convert.ToInt32(ramComboBox.SelectedValue), nameConfig.Text);
                MessageBox.Show("Конфигурация успешно создана");
            }
            else
            {
                MessageBox.Show("Введите название конфигурации");
            }
        }
    }
}
