﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PC_Build_Games_SQL;

namespace PC_Build_Games
{
    /// <summary>
    /// Логика взаимодействия для Profile.xaml
    /// </summary>
    public partial class Profile : Page
    {
        string username;
        public Profile(string username)
        {
            InitializeComponent();
            this.username = username;
            SQL sql = new SQL();
            List<string> list = sql.UserInformation(username);
            nameTextBlock.Text = list[0];
            surnameTextBlock.Text = list[1];
            emailTextBlock.Text = list[2];
        }

        private void passwordChange_Click(object sender, RoutedEventArgs e)
        {
            ChangePassword window = new ChangePassword(username);
            window.ShowDialog();
        }

        private void ChangeUser_Click(object sender, RoutedEventArgs e)
        {
            ChangeUser window = new ChangeUser(username);
            window.ShowDialog();
        }
    }
}
